import { AuthenticationMapper } from '@modules/authentication/authentication.mapper';
import { AuthenticationRepository } from '@modules/authentication/infrastructure/authentication.repository';
import { PrismaService } from '@modules/authentication/infrastructure/prisma.service';
import { EventEmitter2, EventEmitterModule } from '@nestjs/event-emitter';
import { Test, TestingModule } from '@nestjs/testing';

const mockMessagePublisher = {
  publish: jest.fn().mockImplementation(),
};

describe('Authentication repository', () => {
  let prismaService: PrismaService;
  let authenticationMapper: AuthenticationMapper;
  let eventEmitter: EventEmitter2;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      imports: [EventEmitterModule.forRoot()],
      providers: [PrismaService, AuthenticationMapper],
    }).compile();

    prismaService = module.get<PrismaService>(PrismaService);
    authenticationMapper =
      module.get<AuthenticationMapper>(AuthenticationMapper);
    eventEmitter = module.get<EventEmitter2>(EventEmitter2);
  });
  it('should be defined', () => {
    expect(
      new AuthenticationRepository(
        prismaService,
        authenticationMapper,
        eventEmitter,
        mockMessagePublisher,
      ),
    ).toBeDefined();
  });
});
